// Upgrade NOTE: replaced '_Object2World' with 'unity_ObjectToWorld'

// Shader created with Shader Forge v1.28 
// Shader Forge (c) Neat Corporation / Joachim Holmer - http://www.acegikmo.com/shaderforge/
// Note: Manually altering this data may prevent you from opening it in Shader Forge
/*SF_DATA;ver:1.28;sub:START;pass:START;ps:flbk:,iptp:0,cusa:False,bamd:0,lico:1,lgpr:1,limd:0,spmd:1,trmd:0,grmd:0,uamb:True,mssp:True,bkdf:False,hqlp:False,rprd:False,enco:False,rmgx:True,rpth:0,vtps:0,hqsc:True,nrmq:1,nrsp:0,vomd:0,spxs:False,tesm:0,olmd:1,culm:0,bsrc:0,bdst:1,dpts:2,wrdp:True,dith:0,rfrpo:True,rfrpn:Refraction,coma:15,ufog:False,aust:True,igpj:False,qofs:0,qpre:1,rntp:1,fgom:False,fgoc:False,fgod:False,fgor:False,fgmd:0,fgcr:0.2726535,fgcg:0.9044118,fgcb:0.8441553,fgca:1,fgde:0,fgrn:48.46,fgrf:188.2,stcl:False,stva:128,stmr:255,stmw:255,stcp:6,stps:0,stfa:0,stfz:0,ofsf:0,ofsu:0,f2p0:False,fnsp:False,fnfb:False;n:type:ShaderForge.SFN_Final,id:3138,x:34514,y:33055,varname:node_3138,prsc:2|emission-5949-RGB;n:type:ShaderForge.SFN_Tex2d,id:5949,x:34317,y:33155,ptovrint:False,ptlb:thermo,ptin:_thermo,varname:_thermo,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,tex:9214ad951dc1ab24fb5123345080a9e0,ntxv:0,isnm:False|UVIN-8734-OUT;n:type:ShaderForge.SFN_Append,id:8734,x:34130,y:33155,varname:node_8734,prsc:2|A-6041-OUT,B-6967-OUT;n:type:ShaderForge.SFN_Vector1,id:6967,x:34130,y:33096,varname:node_6967,prsc:2,v1:0;n:type:ShaderForge.SFN_VertexColor,id:5517,x:33299,y:33220,varname:node_5517,prsc:2;n:type:ShaderForge.SFN_ValueProperty,id:7033,x:32990,y:33696,ptovrint:True,ptlb:heatlevel,ptin:_heatlevel,varname:_heatlevel,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,v1:0.5;n:type:ShaderForge.SFN_Fresnel,id:104,x:33278,y:33074,varname:node_104,prsc:2|NRM-9295-OUT,EXP-3388-OUT;n:type:ShaderForge.SFN_Vector1,id:3388,x:33087,y:33164,varname:node_3388,prsc:2,v1:1.5;n:type:ShaderForge.SFN_Add,id:6041,x:33945,y:33155,varname:node_6041,prsc:2|A-4167-OUT,B-5371-OUT;n:type:ShaderForge.SFN_NormalVector,id:9295,x:33087,y:33018,prsc:2,pt:False;n:type:ShaderForge.SFN_Multiply,id:4167,x:33575,y:33074,varname:node_4167,prsc:2|A-104-OUT,B-971-OUT;n:type:ShaderForge.SFN_Vector1,id:971,x:33410,y:33138,varname:node_971,prsc:2,v1:0.15;n:type:ShaderForge.SFN_RemapRangeAdvanced,id:5371,x:33742,y:33291,varname:node_5371,prsc:2|IN-5517-G,IMIN-1333-OUT,IMAX-1526-OUT,OMIN-7254-OUT,OMAX-8936-OUT;n:type:ShaderForge.SFN_Vector1,id:1526,x:33299,y:33442,varname:node_1526,prsc:2,v1:1;n:type:ShaderForge.SFN_Vector1,id:1333,x:33299,y:33342,varname:node_1333,prsc:2,v1:0;n:type:ShaderForge.SFN_Subtract,id:5280,x:33299,y:33736,varname:node_5280,prsc:2|A-7033-OUT,B-2118-OUT;n:type:ShaderForge.SFN_Clamp01,id:7254,x:33716,y:33604,varname:node_7254,prsc:2|IN-5280-OUT;n:type:ShaderForge.SFN_Add,id:7272,x:33299,y:33546,varname:node_7272,prsc:2|A-7033-OUT,B-2118-OUT;n:type:ShaderForge.SFN_Vector1,id:2118,x:32990,y:33532,varname:node_2118,prsc:2,v1:0.2;n:type:ShaderForge.SFN_Clamp01,id:8936,x:33501,y:33546,varname:node_8936,prsc:2|IN-7272-OUT;proporder:5949-7033;pass:END;sub:END;*/

Shader "Shader Forge/heatmap_block" {
    Properties {
        _thermo ("thermo", 2D) = "white" {}
        _heatlevel ("heatlevel", Float ) = 0.5
    }
    SubShader {
        Tags {
            "RenderType"="Opaque"
        }
        Pass {
            Name "FORWARD"
            Tags {
                "LightMode"="ForwardBase"
            }
            
            
            CGPROGRAM
            #pragma vertex vert
            #pragma fragment frag
            #define UNITY_PASS_FORWARDBASE
            #include "UnityCG.cginc"
            #pragma multi_compile_fwdbase_fullshadows
            #pragma exclude_renderers gles3 metal d3d11_9x xbox360 xboxone ps3 ps4 psp2 
            #pragma target 3.0
            uniform sampler2D _thermo; uniform float4 _thermo_ST;
            uniform float _heatlevel;
            struct VertexInput {
                float4 vertex : POSITION;
                float3 normal : NORMAL;
                float4 vertexColor : COLOR;
            };
            struct VertexOutput {
                float4 pos : SV_POSITION;
                float4 posWorld : TEXCOORD0;
                float3 normalDir : TEXCOORD1;
                float4 vertexColor : COLOR;
            };
            VertexOutput vert (VertexInput v) {
                VertexOutput o = (VertexOutput)0;
                o.vertexColor = v.vertexColor;
                o.normalDir = UnityObjectToWorldNormal(v.normal);
                o.posWorld = mul(unity_ObjectToWorld, v.vertex);
                o.pos = mul(UNITY_MATRIX_MVP, v.vertex );
                return o;
            }
            float4 frag(VertexOutput i) : COLOR {
                i.normalDir = normalize(i.normalDir);
                float3 viewDirection = normalize(_WorldSpaceCameraPos.xyz - i.posWorld.xyz);
                float3 normalDirection = i.normalDir;
////// Lighting:
////// Emissive:
                float node_1333 = 0.0;
                float node_2118 = 0.2;
                float node_7254 = saturate((_heatlevel-node_2118));
                float2 node_8734 = float2(((pow(1.0-max(0,dot(i.normalDir, viewDirection)),1.5)*0.15)+(node_7254 + ( (i.vertexColor.g - node_1333) * (saturate((_heatlevel+node_2118)) - node_7254) ) / (1.0 - node_1333))),0.0);
                float4 _thermo_var = tex2D(_thermo,TRANSFORM_TEX(node_8734, _thermo));
                float3 emissive = _thermo_var.rgb;
                float3 finalColor = emissive;
                return fixed4(finalColor,1);
            }
            ENDCG
        }
    }
    FallBack "Diffuse"
    CustomEditor "ShaderForgeMaterialInspector"
}
